Package tigase.xmpp.impl

# Class JabberIqRoster

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.JabberIqRoster

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="jabber:iq:roster", parent=SessionManager.class, active=true) public class JabberIqRoster extends XMPPProcessor implements XMPPProcessorIfc
Class `JabberIqRoster` implements part of RFC-3921 - XMPP Instant Messaging specification describing roster management. 7. Roster Management
Created: Tue Feb 21 17:42:53 2006

Author:
  Artur Hefczyc

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ANON`
  `protected static final String`
  `ID`
  `protected RosterAbstract`
  `roster_util`
  instance of class implementing `RosterAbstract`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JabberIqRoster()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `concurrentQueuesNo()`
  Methods returns a preferable number of threads/packets queues for the plugin.
  `protected static void`
  `dynamicGetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)`
  Method processes roster `get` request related to dynamic roster.
  `protected static void`
  `dynamicSetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)`
  Method processes roster `set` request related to dynamic roster.
  `static String[]`
  `getItemGroups(Element item)`
  Returns an array of group names retrieved from Element item
  `int`
  `getMaxRosterSize()`
  `protected RosterAbstract`
  `getRosterUtil()`
  Returns shared instance of class implementing `RosterAbstract` - either default one (`RosterFlat`) or the one configured with "roster-implementation" property.
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `boolean`
  `isEmptyNameAllowed()`
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  Performs processing of IQ packets with jabber:iq:roster xmlns with the regard whether it's roster set or get request or possibly dynamic-roster is involved. request.
  `protected void`
  `processGetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)`
  Method processes roster `get` request.
  `protected void`
  `processSetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)`
  Method processes roster `set` request.
  `void`
  `setEmptyNameAllowed(boolean emptyNameAllowed)`
  `void`
  `setMaxRosterSize(int maxRosterSize)`
  `Element[]`
  `supDiscoFeatures(XMPPResourceConnection session)`
  Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
  `String[][]`
  `supElementNamePaths()`
  Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
  `String[]`
  `supNamespaces()`
  Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
  `Element[]`
  `supStreamFeatures(XMPPResourceConnection session)`
  Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request.
  `protected void`
  `updateHash(XMPPResourceConnection session, Map<String,Object> settings)`
  Calculates hash value based on the user roster items and saves it to user's session data.

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, getComponentInfo, getStatistics, init, supTypes`

- ## Field Details

  - ### ANON

    public static final String ANON
    See Also:
      - Constant Field Values

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

  - ### roster_util

    protected RosterAbstract roster_util
    instance of class implementing `RosterAbstract`

- ## Constructor Details

  - ### JabberIqRoster

    public JabberIqRoster()

- ## Method Details

  - ### dynamicGetRequest

    protected static void dynamicGetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings) throws NotAuthorizedException
    Method processes roster `get` request related to dynamic roster. Generates output packet with data from the DynamicRoster implementation for every itemelement from processed packet or error otherwise.
    Parameters:
      `packet` - packet is which being processed.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data.
      `results` - this a collection with packets which have been generated as input packet processing results.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration.
    Throws:
      `NotAuthorizedException`

  - ### dynamicSetRequest

    protected static void dynamicSetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)
    Method processes roster `set` request related to dynamic roster. Sets extra data for every itemelement from processed packet with the DynamicRoster implementation and generates success packet or, in case of failure generates error.
    Parameters:
      `packet` - packet is which being processed.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data.
      `results` - this a collection with packets which have been generated as input packet processing results.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration.

  - ### getItemGroups

    public static String[] getItemGroups(Element item)
    Returns an array of group names retrieved from Element item
    Parameters:
      `item` - from which groups should be obtained
    Returns:
      an array of group names retrieved from Element item

  - ### concurrentQueuesNo

    public int concurrentQueuesNo()
    Description copied from interface: `XMPPImplIfc`
    Methods returns a preferable number of threads/packets queues for the plugin. This number can be overwritten through configuration settings, however, a default value should be reasonably good for most standard installations. It is recommended to assign at least as much as twice a number of CPUs cores for I/O bound processing and number a number equal to CPUs cores for fast processing not slowed down by any I/O.
    Specified by:
      `concurrentQueuesNo` in interface `XMPPImplIfc`
    Overrides:
      `concurrentQueuesNo` in class `XMPPProcessor`
    Returns:
      an integer preferred number of processing threads for the plugin.

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Returns:
      a `String` value

  - ### isEmptyNameAllowed

    public boolean isEmptyNameAllowed()

  - ### setEmptyNameAllowed

    public void setEmptyNameAllowed(boolean emptyNameAllowed)

  - ### getMaxRosterSize

    public int getMaxRosterSize()

  - ### setMaxRosterSize

    public void setMaxRosterSize(int maxRosterSize)

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Performs processing of IQ packets with jabber:iq:roster xmlns with the regard whether it's roster set or get request or possibly dynamic-roster is involved. request.
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### supDiscoFeatures

    public Element[] supDiscoFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
    Specified by:
      `supDiscoFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supDiscoFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### supElementNamePaths

    public String[][] supElementNamePaths()
    Description copied from interface: `XMPPImplIfc`
    Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
    Specified by:
      `supElementNamePaths` in interface `XMPPImplIfc`
    Overrides:
      `supElementNamePaths` in class `XMPPProcessor`
    Returns:
      a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

  - ### supNamespaces

    public String[] supNamespaces()
    Description copied from interface: `XMPPImplIfc`
    Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
    Specified by:
      `supNamespaces` in interface `XMPPImplIfc`
    Overrides:
      `supNamespaces` in class `XMPPProcessor`
    Returns:
      a `String[]` value

  - ### supStreamFeatures

    public Element[] supStreamFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request. Stream features returned by this method correspond to features supported by this plugin.
    Specified by:
      `supStreamFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supStreamFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### processGetRequest

    protected void processGetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings) throws NotAuthorizedException, TigaseDBException, RosterRetrievingException, RepositoryAccessException
    Method processes roster `get` request. Generates output result packet containing user roster items also considering roster version attribute to minimise traffic.
    Parameters:
      `packet` - packet is which being processed.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data.
      `results` - this a collection with packets which have been generated as input packet processing results.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration.
    Throws:
      `NotAuthorizedException`
      `TigaseDBException`
      `RosterRetrievingException`
      `RepositoryAccessException`

  - ### processSetRequest

    protected void processSetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings) throws XMPPException, NotAuthorizedException, TigaseDBException, PolicyViolationException
    Method processes roster `set` request. Performs modifications of user roster.
    Parameters:
      `packet` - packet is which being processed.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data.
      `results` - this a collection with packets which have been generated as input packet processing results.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration.
    Throws:
      `XMPPException`
      `NotAuthorizedException`
      `TigaseDBException`
      `PolicyViolationException`

  - ### updateHash

    protected void updateHash(XMPPResourceConnection session, Map<String,Object> settings) throws NotAuthorizedException, TigaseDBException, RosterRetrievingException, RepositoryAccessException
    Calculates hash value based on the user roster items and saves it to user's session data.
    Parameters:
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration.
    Throws:
      `NotAuthorizedException`
      `TigaseDBException`
      `RosterRetrievingException`
      `RepositoryAccessException`

  - ### getRosterUtil

    protected RosterAbstract getRosterUtil()
    Returns shared instance of class implementing `RosterAbstract` - either default one (`RosterFlat`) or the one configured with "roster-implementation" property.
    Returns:
      a shared instance of class implementing `RosterAbstract`